﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace TestModelFirst
{
   using System;
   using System.Collections.Generic;

   public class Customers
   {
      public Customers()
      {
         // Automatically obtain a list of purchases from the database.
         this.Purchases = new HashSet<Purchases>();
      }

      // Declare the table properties.
      public int Id { get; set; }
      public string CustomerName { get; set; }

      // Declare the navigational property.
      public virtual ICollection<Purchases> Purchases { get; set; }

      // Declare a custom method.
      public string ToFormattedString()
      {
         // Create a StringBuilder to hold the formatted string.
         StringBuilder Output = new StringBuilder();

         // Add the customer's name.
         Output.Append(this.CustomerName +
                  " has made purchases on: ");

         // Add each purchase on a separate line.
         foreach (Purchases Purchase in this.Purchases)
            Output.Append("\r\n\t" + Purchase.PurchaseDate);

         // Return the formatted string.
         return Output.ToString();
      }

      // Declare a custom property.
      public Decimal PurchaseTotal
      {
         get
         {
            // Create a variable to hold the total.
            Decimal Total = 0;

            // Calculate the purchase total.
            foreach (Purchases Purchase in this.Purchases)
               Total += Purchase.Amount;

            // Return the total to the caller.
            return Total;
         }
      }
   }
}
